//+------------------------------------------------------------------+
//|                                             tickAskBidVolume.mq5 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Canvas\iCanvas_CB.mqh> //https://www.mql5.com/ru/code/22164
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_plots   3
#property indicator_type1   DRAW_HISTOGRAM
#property indicator_type2   DRAW_HISTOGRAM
#property indicator_type3   DRAW_LINE
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_label1  "Ask-Bid>0"
#property indicator_label2  "Bid-Bid<0"
#property indicator_label3  "Ask"

double    AskBuffer[];
double    BidBuffer[];
double    Buffer[];
MqlTick ticks[];
int N;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,AskBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,BidBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,Buffer,INDICATOR_DATA);
   ArraySetAsSeries(AskBuffer,true);
   ArraySetAsSeries(BidBuffer,true);
   ArraySetAsSeries(Buffer,true);
   IndicatorSetString(INDICATOR_SHORTNAME,"TickVol");
   PlotIndexSetString(0,PLOT_LABEL,"Ask>Bid");
   PlotIndexSetString(1,PLOT_LABEL,"Ask<Bid");
   PlotIndexSetString(2,PLOT_LABEL,"TickVolAsk");
   EventSetTimer(2);
   N=LoadTicks();
//--- initialization done
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTimer()
  {
   if(N<100) N=LoadTicks();
  }
//+------------------------------------------------------------------+
//| Relative Vigor Index                                             |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,const int prev_calculated,const int begin,const double &price[])
  {
   N=LoadTicks();
   //Print(N);
   return(rates_total);
  }
  
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
    if(id==CHARTEVENT_CHART_CHANGE) N=LoadTicks();
  }
//+------------------------------------------------------------------+
int LoadTicks()
  {
   ulong T0=GetMicrosecondCount();
   ulong t0=1000*W.time[0];
   ulong t1=1000*W.time[W.BarsInWind-1];
   int n=CopyTicksRange(_Symbol,ticks,COPY_TICKS_ALL,t0,t1);
   int j=W.BarsInWind-1;
   ArrayInitialize(Buffer,0);
   int t=1;
   int sa=0,sb=0;
   int pre_ask=0;
   int pre_bid=0;
   if (ArraySize(AskBuffer)==0) return n;
   for(int i=1; i<n; i++)
     {
      if(j>=0) if(ticks[i].time>=W.time[t])
        {
          int jj=sa+sb;
          if (jj>0) {AskBuffer[j+(int)W.Right_bar]=jj; BidBuffer[j+(int)W.Right_bar]=0;}
          else {AskBuffer[j+(int)W.Right_bar]=0; BidBuffer[j+(int)W.Right_bar]=jj;}
          //Buffer[j+(int)W.Right_bar]=sa+sb;
          j--;
          t++;
          sa=0;
          sb=0;
        }
      if(ticks[i].ask>ticks[i-1].ask) sa++;
      else if(ticks[i].ask<ticks[i-1].ask) sa--;
      if(ticks[i].bid>ticks[i-1].bid) sb++;
      else if(ticks[i].bid<ticks[i-1].bid) sb--;

     }
   return int(GetMicrosecondCount()-T0);
  }
//+------------------------------------------------------------------+
